/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.67 by adcroft, Tue Feb 24 19:00:32 2004 UTC revision 1.113 by edhill, Sun Dec 26 16:38:20 2004 UTC
# Line 37  test_for_string_in_file() { Line 37  test_for_string_in_file() {
37      grep -i "$strng" $file > /dev/null 2>&1      grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo -n "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
41          grep -i "$strng" $file          grep -i "$strng" $file
42          return 1          return 1
43      fi      fi
# Line 67  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    .SUFFIXES:
128    .SUFFIXES: .$tfs .F
129    .F.$tfs:
130            $LN \$< \$@
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
# Line 80  find_possible_configs()  { Line 245  find_possible_configs()  {
245      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
253            
# Line 100  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # makedepend is not always available      look_for_makedepend
271      if test "x${MAKEDEPEND}" = x ; then  
272        which makedepend >& /dev/null      #================================================================
273        RETVAL=$?      #  look for possible C compilers
274        if test "x${RETVAL}" = x1 ; then      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275           echo "    makedepend was not found. Using xmakedpend instead."      p_CC=
276           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'      for c in $tmp ; do
277        fi          rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309      fi      fi
310    
311      # look for possible fortran compilers      #================================================================
312        #  look for possible FORTRAN compilers
313      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
# Line 136  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 224  get_pdepend_list()  { Line 423  get_pdepend_list()  {
423      . ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
# Line 238  Usage: "$0" [OPTIONS] Line 437  Usage: "$0" [OPTIONS]
437      -help | --help | -h | --h      -help | --help | -h | --h
438            Print this help message and exit.            Print this help message and exit.
439    
440        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442              Use "NAME" as the adoptfile.  By default, the file at
443              "tools/adjoint_options/adjoint_default" will be used.
444    
445      -nooptfile | --nooptfile      -nooptfile | --nooptfile
446        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 262  Usage: "$0" [OPTIONS] Line 466  Usage: "$0" [OPTIONS]
466        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
467            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
468    
469        -makedepend NAME | -md NAME
470          --makedepend=NAME | -md=NAME
471              Use "NAME" for the MAKEDEPEND program.
472    
473      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 298  Usage: "$0" [OPTIONS] Line 506  Usage: "$0" [OPTIONS]
506            will search for a working compiler by trying a list of            will search for a working compiler by trying a list of
507            "usual suspects" such as g77, f77, etc.            "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514      -[no]ieee | --[no]ieee      -[no]ieee | --[no]ieee
515            Do or don't use IEEE numerics.  Note that this option            Do or don't use IEEE numerics.  Note that this option
516            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
# Line 307  Usage: "$0" [OPTIONS] Line 520  Usage: "$0" [OPTIONS]
520            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
521      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
522            Include MPI header files and link to MPI libraries using MPI_ROOT            Include MPI header files and link to MPI libraries using MPI_ROOT
523            set to PATH. i.e. Include files from $PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
524            from $PATH/lib and use binaries from $PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
530    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
# Line 330  EOF Line 546  EOF
546    
547  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
548  get_fortran_c_namemangling()  {  get_fortran_c_namemangling()  {
549    
550        #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551        if test ! "x$FC_NAMEMANGLE" = x ; then
552            return 0
553        fi
554    
555      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556            
557      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
# Line 347  WARNING: Please contact <MITgcm-support@ Line 569  WARNING: Please contact <MITgcm-support@
569  EOF  EOF
570          return 1          return 1
571      fi      fi
572      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573      RETVAL=$?      RETVAL=$?
574      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
575          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 377  WARNING: Please contact <MITgcm-support@ Line 599  WARNING: Please contact <MITgcm-support@
599  EOF  EOF
600          return 1          return 1
601      fi      fi
602      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603      RETVAL=$?      RETVAL=$?
604      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
605          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 453  EOF Line 675  EOF
675  }  }
676    
677    
678    check_HAVE_STAT()  {
679        get_fortran_c_namemangling
680        cat <<EOF > genmake_tc_1.c
681    $FC_NAMEMANGLE
682    #include <stdio.h>
683    #include <stdlib.h>
684    #include <unistd.h>
685    #include <sys/stat.h>
686    #include <sys/types.h>
687    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
688    {
689        char name[512];
690        struct stat astat;
691    
692        name[0] = 'a'; name[1] = '\0';
693        if (! stat(name, &astat))
694            *nbyte = (int)(astat.st_size);
695        else
696            *nbyte = -1;
697    }
698    EOF
699        make genmake_tc_1.o >> genmake_tc.log 2>&1
700        RET_C=$?
701        cat <<EOF > genmake_tc_2.f
702          program hello
703          integer nbyte
704          call tfsize(nbyte)
705          print *," HELLO WORLD", nbyte
706          end program hello
707    EOF
708        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
709        RET_F=$?
710        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
711        RETVAL=$?
712        if test "x$RETVAL" = x0 ; then
713            HAVE_STAT=t
714            DEFINES="$DEFINES -DHAVE_STAT"
715        fi
716        rm -f genmake_tc*
717    }
718    
719    
720  check_netcdf_libs()  {  check_netcdf_libs()  {
721      cat <<EOF > genmake_tnc.F      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
722            return
723        fi
724        echo "" > genmake_tnc.log
725        cat <<EOF > genmake_tnc.for
726        program fgennc        program fgennc
727  #include "netcdf.inc"  #include "netcdf.inc"
728    EOF
729        if test ! "x$MPI" = x ; then
730            echo '#include "mpif.h"' >> genmake_tnc.for
731        fi
732        cat <<EOF >> genmake_tnc.for
733        integer iret, ncid, xid        integer iret, ncid, xid
734        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
735        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 466  check_netcdf_libs()  { Line 739  check_netcdf_libs()  {
739        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
740        end        end
741  EOF  EOF
742      $CPP genmake_tnc.F > genmake_tnc.f  \      echo "Executing:" > genmake_tnc.log
743          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1      echo "  $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f" \
744            > genmake_tnc.log
745        RET_CPP=f
746        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
747            &&  RET_CPP=t
748        if test "x$RET_CPP" = xf ; then
749            echo "  WARNING: CPP failed to pre-process the netcdf test." \
750                > genmake_tnc.log
751            echo "    Please check that \$INCLUDES is properly set." \
752                > genmake_tnc.log
753        fi
754        echo "Executing:" > genmake_tnc.log
755        echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.f" > genmake_tnc.log
756        echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log
757        $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
758            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
759      RET_COMPILE=$?      RET_COMPILE=$?
760      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1  
761      RETVAL=$?      #EH3  Remove test program execution for machines that either disallow
762      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then      #EH3  execution or cannot support it (eg. cross-compilers)
763        #EH3
764        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
765        #EH3 RETVAL=$?
766        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
767    
768        if test "x$RET_COMPILE" = x0 ; then
769          HAVE_NETCDF=t          HAVE_NETCDF=t
770      else      else
771          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
772          $CPP genmake_tnc.F > genmake_tnc.f  \          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
773              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
774              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
775          RET_COMPILE=$?          RET_COMPILE=$?
776          test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1          if test "x$RET_COMPILE" = x0 ; then
         RETVAL=$?  
         if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then  
777              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
778              HAVE_NETCDF=t              HAVE_NETCDF=t
779          else          else
# Line 505  LN= Line 797  LN=
797  S64=  S64=
798  KPP=  KPP=
799  FC=  FC=
800    #CC=gcc
801  CPP=  CPP=
802  LINK=  LINK=
803  DEFINES=  DEFINES=
# Line 512  PACKAGES= Line 805  PACKAGES=
805  ENABLE=  ENABLE=
806  DISABLE=  DISABLE=
807  MAKEFILE=  MAKEFILE=
808  MAKEDEPEND=  #MAKEDEPEND=
809  PDEPEND=  PDEPEND=
810  DUMPSTATE=t  DUMPSTATE=t
811  PDEFAULT=  PDEFAULT=
812  OPTFILE=  OPTFILE=
813  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
814  FFLAGS=  FFLAGS=
815  FOPTIM=  FOPTIM=
816  CFLAGS=  CFLAGS=
817  KFLAGS1=  KFLAGS1=
818  KFLAGS2=  KFLAGS2=
819    #LDADD=
820  LIBS=  LIBS=
821  KPPFILES=  KPPFILES=
822  NOOPTFILES=  NOOPTFILES=
# Line 535  HAVE_SYSTEM= Line 829  HAVE_SYSTEM=
829  HAVE_FDATE=  HAVE_FDATE=
830  FC_NAMEMANGLE=  FC_NAMEMANGLE=
831  HAVE_CLOC=  HAVE_CLOC=
832    HAVE_STAT=
833  HAVE_NETCDF=  HAVE_NETCDF=
834    HAVE_ETIME=
835    
836  MODS=  MODS=
837  TOOLSDIR=  TOOLSDIR=
# Line 543  SOURCEDIRS= Line 839  SOURCEDIRS=
839  INCLUDEDIRS=  INCLUDEDIRS=
840  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
841    
842    G2ARGS=
843    BASH=
844  PWD=`pwd`  PWD=`pwd`
845  MAKE=make  MAKE=make
846  AWK=awk  AWK=awk
847  THISHOSTNAME=`hostname`  THISHOST=`hostname`
848  THISCWD=`pwd`  THISCWD=`pwd`
849  THISDATE=`date`  THISDATE=`date`
850    THISUSER=`echo $USER`
851    THISVER=
852  MACHINE=`uname -a`  MACHINE=`uname -a`
853  EXECUTABLE=  EXECUTABLE=
854  EXEHOOK=  EXEHOOK=
# Line 558  IEEE= Line 858  IEEE=
858  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
859      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
860  fi  fi
861    FS=
862    FS90=
863    
864  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
865  AD_OPTFILE=  AD_OPTFILE=
# Line 580  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STA Line 882  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STA
882  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
883  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
884  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
885  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
886  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
887  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
888    
889  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
890  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 611  for i in . $MODS ; do Line 913  for i in . $MODS ; do
913          break          break
914      fi      fi
915  done  done
916  echo -n "  getting local config information:  "  printf "  getting local config information:  "
917  if test -e $gm_local ; then  if test -f $gm_local ; then
918      echo "using $gm_local"      echo "using $gm_local"
919      . $gm_local      . $gm_local
920      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 621  else Line 923  else
923      echo "none found"      echo "none found"
924  fi  fi
925    
926  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
927  #OPTIONS=  #OPTIONS=
928  #n=0  #n=0
929  #for i ; do  #for i ; do
# Line 633  fi Line 935  fi
935  #done  #done
936  #parse_options  #parse_options
937  ac_prev=  ac_prev=
938  for ac_option ; do  for ac_option in "$@" ; do
939    
940        G2ARGS="$G2ARGS \"$ac_option\""
941    
942      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
943      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 676  for ac_option ; do Line 980  for ac_option ; do
980          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
981              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
982                    
983            -bash | --bash)
984                ac_prev=BASH ;;
985            -bash=* | --bash=*)
986                BASH=$ac_optarg ;;
987            
988            -makedepend | --makedepend | -md | --md)
989                ac_prev=MAKEDEPEND ;;
990            -makedepend=* | --makedepend=* | -md=* | --md=*)
991                MAKEDEPEND=$ac_optarg ;;
992            
993          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
994              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
995          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 717  for ac_option ; do Line 1031  for ac_option ; do
1031  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
1032  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
1033  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
1034                        
1035            -cc | --cc)
1036                ac_prev=CC ;;
1037            -cc=* | --cc=*)
1038                CC=$ac_optarg ;;
1039            
1040          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
1041              ac_prev=FC ;;              ac_prev=FC ;;
1042          -fc=* | --fc=*)          -fc=* | --fc=*)
1043              FC=$ac_optarg ;;              FC=$ac_optarg ;;
1044                    
1045            -fs | --fs)
1046                ac_prev=FS ;;
1047            -fs=* | --fs=*)
1048                FS=$ac_optarg ;;
1049            
1050            -fs90 | --fs90)
1051                ac_prev=FS90 ;;
1052            -fs90=* | --fs90=*)
1053                FS90=$ac_optarg ;;
1054            
1055          -ieee | --ieee)          -ieee | --ieee)
1056              IEEE=true ;;              IEEE=true ;;
1057          -noieee | --noieee)          -noieee | --noieee)
# Line 778  if test -f ./.genmakerc ; then Line 1107  if test -f ./.genmakerc ; then
1107      echo      echo
1108  fi  fi
1109    
1110    #  Find the MITgcm ${ROOTDIR}
1111  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1112      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1113        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1114          ROOTDIR=".."          ROOTDIR=".."
1115      else      else
1116          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1117              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1118                  ROOTDIR=$d                  ROOTDIR=$d
1119                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1120                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1121                  break                  break
1122              fi              fi
# Line 803  if test ! -d ${ROOTDIR} ; then Line 1134  if test ! -d ${ROOTDIR} ; then
1134      exit 1      exit 1
1135  fi  fi
1136    
1137    #  Find the MITgcm ${THISVER}
1138    if test -f "${ROOTDIR}/doc/tag-index" ; then
1139        THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`
1140    fi
1141    
1142  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1143  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1144      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 819  if test "x$OPTFILE" != xNONE ; then Line 1155  if test "x$OPTFILE" != xNONE ; then
1155          . "$OPTFILE"          . "$OPTFILE"
1156          RETVAL=$?          RETVAL=$?
1157          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1158              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1159              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1160              exit 1              exit 1
1161          fi          fi
# Line 832  if test "x$OPTFILE" != xNONE ; then Line 1168  if test "x$OPTFILE" != xNONE ; then
1168      fi      fi
1169  fi  fi
1170    
1171    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1172    # check_for_broken_Ff
1173    
1174  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1175  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1176      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 846  if test "x${AD_OPTFILE}" != xNONE ; then Line 1185  if test "x${AD_OPTFILE}" != xNONE ; then
1185          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1186          RETVAL=$?          RETVAL=$?
1187          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1188              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1189              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1190              exit 1              exit 1
1191          fi          fi
# Line 859  if test "x${AD_OPTFILE}" != xNONE ; then Line 1198  if test "x${AD_OPTFILE}" != xNONE ; then
1198      fi      fi
1199  fi  fi
1200    
1201  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1202  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1203    if test ! "x$BASH" = x ; then
1204        # add a trailing space so that it works within the Makefile syntax (see below)
1205        BASH="$BASH "
1206    fi
1207  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1208      cat <<EOF 1>&2      cat <<EOF 1>&2
1209    
# Line 871  Error: no Fortran compiler: please speci Line 1214  Error: no Fortran compiler: please speci
1214  EOF  EOF
1215      exit 1      exit 1
1216  fi  fi
1217    if test "x$CC" = x ; then
1218        CC=cc
1219    #     cat <<EOF 1>&2
1220    # Error: no C compiler: please specify using one of the following:
1221    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1222    #   2) the "-cc=XXX" command-line option
1223    #   3) the "./genmake_local" file
1224    # EOF
1225    #     exit 1
1226    fi
1227  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1228      LINK=$FC      LINK=$FC
1229  fi  fi
# Line 881  if test "x$CPP" = x ; then Line 1234  if test "x$CPP" = x ; then
1234      CPP=cpp      CPP=cpp
1235  fi  fi
1236  #EH3 === UGLY ===  #EH3 === UGLY ===
1237  #  The following an ugly little hack to check for $CPP in /lib/ and it  #  The following is an ugly little hack to check for $CPP in /lib/ and
1238  #  should eventually be replaced with a more general function that  #  it should eventually be replaced with a more general function that
1239  #  searches a combo of the user's path and a list of "usual suspects"  #  searches a combo of the user's path and a list of "usual suspects"
1240  #  to find the correct location for binaries such as $CPP.  #  to find the correct location for binaries such as $CPP.
1241  for i in " " "/lib/" ; do  for i in " " "/lib/" ; do
# Line 905  EOF Line 1258  EOF
1258  else  else
1259      rm -f test_cpp      rm -f test_cpp
1260  fi  fi
1261  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1262  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1263      LN="ln -s"      LN="ln -s"
1264  fi  fi
# Line 925  EOF Line 1276  EOF
1276  fi  fi
1277  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1278    
1279    #  Check for broken *.F/*.f handling and fix if possible
1280    check_for_broken_Ff
1281    
1282  if test ! "x$MPI" = x ; then  if test ! "x$MPI" = x ; then
1283        echo "  Turning on MPI cpp macros"        echo "  Turning on MPI cpp macros"
1284        DEFINES="$DEFINS -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1285  fi  fi
1286    
1287  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1288  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1289  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1290        program hello        program hello
1291        call system('echo hi')        call system('echo hi')
# Line 949  else Line 1303  else
1303  fi  fi
1304  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1305    
1306  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1307  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1308        program hello        program hello
1309        CHARACTER(128) string        CHARACTER(128) string
# Line 970  else Line 1324  else
1324  fi  fi
1325  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1326    
1327  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1328    cat > genmake_tcomp.f <<EOF
1329          program hello
1330          REAL*4 ACTUAL, TARRAY(2)
1331          EXTERNAL ETIME
1332          REAL*4 ETIME
1333          actual = etime( tarray )
1334          print *, tarray
1335          end
1336    EOF
1337    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1338    RETVAL=$?
1339    if test "x$RETVAL" = x0 ; then
1340        HAVE_ETIME=t
1341        DEFINES="$DEFINES -DHAVE_ETIME"
1342        echo "yes"
1343    else
1344        HAVE_ETIME=
1345        echo "no"
1346    fi
1347    rm -f genmake_tcomp*
1348    
1349    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1350  check_HAVE_CLOC  check_HAVE_CLOC
1351  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1352      echo "yes"      echo "yes"
# Line 979  else Line 1355  else
1355  fi  fi
1356  rm -f genmake_t*  rm -f genmake_t*
1357    
1358  echo -n "  Can we create NetCDF-enabled binaries...  "  printf "  Can we use stat() through C calls...  "
1359    check_HAVE_STAT
1360    if test "x$HAVE_STAT" != x ; then
1361        echo "yes"
1362    else
1363        echo "no"
1364    fi
1365    rm -f genmake_t*
1366    
1367    printf "  Can we create NetCDF-enabled binaries...  "
1368  check_netcdf_libs  check_netcdf_libs
1369  if test "x$HAVE_NETCDF" != x ; then  if test "x$HAVE_NETCDF" != x ; then
1370      echo "yes"      echo "yes"
# Line 989  fi Line 1374  fi
1374    
1375    
1376  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1377  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1378  for d in $MODS ; do  for d in $MODS ; do
1379      if test ! -d $d ; then      if test ! -d $d ; then
1380          echo          echo
1381          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1382          exit 1          exit 1
1383      else      else
1384          echo -n " $d"          printf " $d"
1385          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1386          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1387      fi      fi
# Line 1011  if test "x${PLATFORM}" = x ; then Line 1396  if test "x${PLATFORM}" = x ; then
1396  fi  fi
1397    
1398  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1399      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1400        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1401          EXEDIR=../exe          EXEDIR=../exe
1402      else      else
1403          EXEDIR=.          EXEDIR=.
# Line 1030  if test ! -d ${TOOLSDIR} ; then Line 1416  if test ! -d ${TOOLSDIR} ; then
1416      exit 1      exit 1
1417  fi  fi
1418  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1419      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1420        RETVAL=$?
1421        if test "x${RETVAL}" = x0 ; then
1422            S64='$(TOOLSDIR)/set64bitConst.sh'
1423        else
1424            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1425            RETVAL=$?
1426            if test "x${RETVAL}" = x0 ; then
1427                S64='$(TOOLSDIR)/set64bitConst.csh'
1428            else
1429                cat <<EOF
1430    
1431    ERROR: neither of the two default scripts:
1432    
1433        ${TOOLSDIR}/set64bitConst.sh
1434        ${TOOLSDIR}/set64bitConst.csh
1435    
1436      are working so please check paths or specify (with \$S64) a
1437      working version of this script.
1438    
1439    EOF
1440                exit 1
1441            fi
1442        fi
1443  fi  fi
1444  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1445    
# Line 1121  else Line 1530  else
1530          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1531          RETVAL=$?          RETVAL=$?
1532          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1533              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1534              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1535              exit 1              exit 1
1536          fi          fi
# Line 1129  else Line 1538  else
1538              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1539          done          done
1540          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1541          expand_pkg_groups          RET=1
1542            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1543          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1544      fi      fi
1545  fi  fi
1546    
1547  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1548    for i in $PACKAGES ; do
1549        echo $i >> ./.tmp_pack
1550    done
1551    for i in `grep  "-" ./.tmp_pack` ; do
1552        j=`echo $i | sed 's/[-]//'`
1553        DISABLE="$DISABLE $j"
1554    done
1555  pack=  pack=
1556  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1557      addit="t"      addit="t"
# Line 1151  PACKAGES="$pack" Line 1568  PACKAGES="$pack"
1568  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1569  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1570  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1571    # Test if each explicitly referenced package exists
1572  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1573      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1574        if test ! -d "$ROOTDIR/pkg/$j" ; then
1575          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1576          exit 1          exit 1
1577      fi      fi
1578      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1579  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1580  PACKAGES=  PACKAGES=
1581  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1582      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1583  done  done
1584    rm -f ./.tmp_pack
1585  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1586    
1587    #  Check availability of NetCDF and then either build the MNC template
1588    #  files or delete mnc from the list of available packages.
1589    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1590    RETVAL=$?
1591    if test "x$RETVAL" = x0 ; then
1592        if test "x$HAVE_NETCDF" != xt ; then
1593            cat <<EOF
1594    
1595    *********************************************************************
1596    WARNING: the "mnc" package was enabled but tests failed to compile
1597      NetCDF applications.  Please check that:
1598    
1599      1) NetCDF is correctly installed for this compiler and
1600      2) the LIBS variable (within the "optfile") specifies the correct
1601           NetCDF library to link against.
1602    
1603      Due to this failure, the "mnc" package is now DISABLED.
1604    *********************************************************************
1605    
1606    EOF
1607            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1608            DISABLE="$DISABLE mnc"
1609        else
1610            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1611            RETVAL=$?
1612            if test "x${RETVAL}" = x0 ; then
1613                rm -f make_mnc.errors
1614            else
1615                echo "Error: problem encountered while building source files in pkg/mnc:"
1616                cat make_mnc.errors 1>&2
1617                exit 1
1618            fi
1619        fi
1620    fi
1621    
1622  echo "  applying package dependency rules"  echo "  applying package dependency rules"
1623  ck=  ck=
1624  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 1230  while test "x$ck" != xtt ; do Line 1683  while test "x$ck" != xtt ; do
1683              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1684              exit 1              exit 1
1685          fi          fi
1686          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1687            #i=$(( $i + 1 ))
1688      done      done
1689      ck=$ck"t"      ck=$ck"t"
1690  done  done
# Line 1249  for i in $PACKAGES ; do Line 1703  for i in $PACKAGES ; do
1703      fi      fi
1704  done  done
1705    
 #  Build MNC templates and check for ability to build and use NetCDF  
 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" = x0 ; then  
     ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1  
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         rm -f make_mnc.errors  
     else  
         echo "Error: problem encountered while building source files in pkg/mnc:"  
         cat make_mnc.errors 1>&2  
         exit 1  
     fi  
     if test "x$HAVE_NETCDF" != xt ; then  
         cat <<EOF  
   
 WARNING: the "mnc" package has been enabled but tests failed to  
   compile and/or execute NetCDF applications.  Please check that:  
   
   1) NetCDF is installed for your compiler and  
   2) the LIBS variable (within the 'optfile") specifies the correct  
        NetCDF library to link against.  
     
 EOF  
     fi  
 fi  
   
1706  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1707  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
1708  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 1392  echo Line 1819  echo
1819  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1820  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1821  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1822      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1823          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1824      fi      fi
1825  done  done
# Line 1404  rm -rf .links.tmp Line 1829  rm -rf .links.tmp
1829  mkdir .links.tmp  mkdir .links.tmp
1830  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1831  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1832  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1833  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1834  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1835  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1836  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1837  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1838  for d in $alldirs ; do  for d in $alldirs ; do
1839      deplist=      deplist=
# Line 1424  for d in $alldirs ; do Line 1849  for d in $alldirs ; do
1849                          ;;                          ;;
1850                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
1851                          ;;                          ;;
1852                      ./BUILD_INFO.h)
1853                            ;;
1854                    *)                    *)
1855                          touch .links.tmp/$sf                          touch .links.tmp/$sf
1856                          deplist="$deplist $sf"                          deplist="$deplist $sf"
# Line 1433  for d in $alldirs ; do Line 1860  for d in $alldirs ; do
1860                  case $extn in                  case $extn in
1861                      F)                      F)
1862                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1863                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1864                          ;;                          ;;
1865                      F90)                      F90)
1866                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1867                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1868                          ;;                          ;;
1869                      c)                      c)
1870                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1871                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1872                          ;;                          ;;
1873                      h)                      h)
1874                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1875                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1876                          ;;                          ;;
1877                      flow)                      flow)
1878                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1879                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1880                          ;;                          ;;
1881                  esac                  esac
1882              fi              fi
# Line 1469  echo "" >> f90srclist.inc Line 1896  echo "" >> f90srclist.inc
1896  echo "" >> hlist.inc  echo "" >> hlist.inc
1897  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1898    
1899  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1900      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1901  fi  fi
1902  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1478  echo "#    $MACHINE" >> $MAKEFILE Line 1905  echo "#    $MACHINE" >> $MAKEFILE
1905  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1906  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1907  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1908  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1909  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1910  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
1911    
1912  EXE_AD=$EXECUTABLE"_ad"  EXE_AD=$EXECUTABLE"_ad"
1913  EXE_FTL=$EXECUTABLE"_ftl"  EXE_FTL=$EXECUTABLE"_ftl"
# Line 1526  ENABLED_PACKAGES = ${ENABLED_PACKAGES} Line 1953  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1953  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1954    
1955  # These files are created by Makefile  # These files are created by Makefile
1956  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
1957    
1958  EOF  EOF
1959    
# Line 1545  KPP = ${KPP} Line 1972  KPP = ${KPP}
1972  FC = ${FC}  FC = ${FC}
1973  # Fortran compiler  # Fortran compiler
1974  F90C = ${F90C}  F90C = ${F90C}
1975    # C compiler
1976    CC = ${CC}
1977  # Link editor  # Link editor
1978  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1979    
1980  # Defines for CPP  # Defines for CPP
1981  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1567  CFLAGS = ${CFLAGS} Line 1996  CFLAGS = ${CFLAGS}
1996  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
1997  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
1998  # Flags and libraries needed for linking  # Flags and libraries needed for linking
1999  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
2000  # Name of the Mekfile  # Name of the Mekfile
2001  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
2002    
# Line 1578  cat csrclist.inc      >> $MAKEFILE Line 2007  cat csrclist.inc      >> $MAKEFILE
2007  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
2008  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
2009  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2010  echo               >> $MAKEFILE  echo >> $MAKEFILE
2011  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2012  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
2013  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2014    echo >> $MAKEFILE
2015    echo '.SUFFIXES:' >> $MAKEFILE
2016    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2017  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2018  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
2019    
2020  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2021    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
2022  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2023  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
2024          @echo Creating \$@ ...          @echo Creating \$@ ...
2025          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2026  depend:  depend:
2027          @make links          @make links
2028          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2029          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2030            -rm -f makedepend.out
2031    
2032  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2033    
# Line 1609  output.txt: \$(EXECUTABLE) Line 2038  output.txt: \$(EXECUTABLE)
2038          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2039    
2040  clean:  clean:
2041          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2042  Clean:  Clean:
2043          @make clean          @make clean
2044          @make cleanlinks          @make cleanlinks
# Line 1620  CLEAN: Line 2049  CLEAN:
2049          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2050          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2051          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2052          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
2053    
2054  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2055  makefile:  makefile:
2056          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
2057  cleanlinks:  cleanlinks:
2058          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2059    
2060  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are create by make
2061  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2062          @echo Creating \$@ ...          @echo Creating \$@ ...
2063          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2064  AD_CONFIG.h:  AD_CONFIG.h:
2065          @echo Creating \$@ ...          @echo Creating \$@ ...
2066          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2067  FC_NAMEMANGLE.h:  FC_NAMEMANGLE.h:
2068          @echo Creating \$@ ...          @echo Creating \$@ ...
2069          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
2070    
2071  # The normal chain of rules is (  .F - .f - .o  )  BUILD_INFO.h:
2072  .F.f:          @echo Creating \$@ ...
2073    EOF
2074    
2075    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
2076    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2077    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2078    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2079    
2080    cat >>$MAKEFILE <<EOF
2081    
2082    # The normal chain of rules is (  .F - .$FS - .o  )
2083    
2084    ## This nullifies any default implicit rules concerning these two file types:
2085    ## %.o : %.F
2086    
2087    .F.$FS:
2088          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2089  .f.o:  .$FS.o:
2090          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2091  .F90.f90:  .F90.$FS90:
2092          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2093  .f90.o:  .$FS90.o:
2094          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2095  .c.o:  .c.o:
2096          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
2097    
2098  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2099  .F.p:  .F.p:
2100          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2101  .p.f:  .p.$FS:
2102          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2103    
2104  #=========================================  #=========================================
# Line 1681  done Line 2125  done
2125    
2126  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2127  echo >> $MAKEFILE  echo >> $MAKEFILE
2128  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2129  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
2130  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2131      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2132      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2133  done  done
2134  echo >> $MAKEFILE  echo >> $MAKEFILE
2135  rm -f ad_files  rm -f ad_files
# Line 1698  adtaf: ad_taf_output.f Line 2142  adtaf: ad_taf_output.f
2142  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
2143    
2144  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2145          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2146          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2147          -rm -f ad_config.template          -rm -f ad_config.template
2148          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1723  ad_tamc_output.f: ad_input_code.f Line 2167  ad_tamc_output.f: ad_input_code.f
2167  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2168          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2169    
2170    adonlyfwd:
2171            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2172    
2173    adtrick:
2174            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2175    
2176  # ... FTL ...  # ... FTL ...
2177  ftlall: ftl_taf  ftlall: ftl_taf
# Line 1730  ftltaf: ftl_taf_output.f Line 2179  ftltaf: ftl_taf_output.f
2179  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
2180    
2181  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2182          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2183          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2184          -rm -f ftl_config.template          -rm -f ftl_config.template
2185          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1758  ftl_tamc: ftl_tamc_output.o \$(OBJFILES) Line 2207  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2207    
2208  # ... SVD ...  # ... SVD ...
2209  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.f ftl_taf_output.f
2210  svdall: svd_taf          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2211            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2212    svdall: svd_touch svd_taf
2213    
2214  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)  svd_taf: \$(OBJFILES)
2215          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2216    
2217            @echo "--->>> Only COMPILE svd code! <<<---"
2218            @echo "--->>> Assumes you previously <<<---"
2219            @echo "--->>> did make svdtaf        <<<---"
2220    
2221    svd_touch:
2222            @echo "--->>> Only COMPILE svd code! <<<---"
2223            @echo "--->>> Assumes you previously <<<---"
2224            @echo "--->>> did make svdtaf        <<<---"
2225            touch ad_taf_output.f ftl_taf_output.f
2226            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.f
2227            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.f
2228            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2229            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2230            -rm -f ftl_config.template
2231    
2232  #=========================================  #=========================================
2233    
# Line 1779  for i in $KPPFILES ; do Line 2244  for i in $KPPFILES ; do
2244      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2245          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2246      fi      fi
2247      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2248  done  done
2249    
2250  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1789  for i in $NOOPTFILES ; do Line 2254  for i in $NOOPTFILES ; do
2254      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2255          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2256      fi      fi
2257      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2258      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2259  done  done
2260    
# Line 1803  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2268  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2268  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2269    
2270  # Create special header files  # Create special header files
2271  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2272  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2273      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2274  else  else
# Line 1817  else Line 2282  else
2282      fi      fi
2283  fi  fi
2284  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2285      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2286  fi  fi
2287    
2288    
2289  #  Write the "state" for future records  #  Write the "state" for future records
2290  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2291      echo -n "" > genmake_state      printf "" > genmake_state
2292      for i in $gm_state ; do      for i in $gm_state ; do
2293          t1="t2=\$$i"          t1="t2=\$$i"
2294          eval $t1          eval $t1

Legend:
Removed from v.1.67  
changed lines
  Added in v.1.113

  ViewVC Help
Powered by ViewVC 1.1.22